diff --git a/src/common/resources/lang/en_US/item.lang b/src/common/resources/lang/en_US/item.lang
index 2f0bee17e..dbe4c551b 100644
--- a/src/common/resources/lang/en_US/item.lang
+++ b/src/common/resources/lang/en_US/item.lang
@@ -419,4 +419,7 @@ item.rope.name=Rope
 item.rope.desc=Strong enough to climb.
 
 item.wand.monster.name=Summoning Wand
-item.wand.monster.desc=A magical tool allowing the wielder to manifest living entities.
\ No newline at end of file
+item.wand.monster.desc=A magical tool allowing the wielder to manifest living entities.
+
+item.paintbrush.name=Paintbrush
+item.paintbrush.desc=Can be loaded with dye and used to paint blocks.
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/entity/particle/FluidDripParticle.java b/src/main/java/net/minecraft/client/entity/particle/FluidDripParticle.java
new file mode 100644
index 000000000..8dccbafb5
--- /dev/null
+++ b/src/main/java/net/minecraft/client/entity/particle/FluidDripParticle.java
@@ -0,0 +1,117 @@
+package net.minecraft.client.entity.particle;
+
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.ParticleEngine;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+
+public class FluidDripParticle extends Particle
+{
+    float maxSize;
+    boolean fullBright;
+
+    public FluidDripParticle(final World world, final double x, final double y, final double z, int color, IconCoordinate texture)
+    {
+        super(world, x, y, z, 0.0, 0.0, 0.0);
+        tex = texture;
+        gravity = 0.125F;
+        size /= 4.0F;
+        maxSize = size;
+        size = 0F;
+        lifetime *= 16.0F;
+        yd = 0.0f;
+        xd = 0.0f;
+        zd = 0.0f;
+
+        rCol = Color.redFromInt(color)/255f;
+        gCol = Color.greenFromInt(color)/255f;
+        bCol = Color.blueFromInt(color)/255f;
+    }
+
+    @Override
+    public int getParticleTexture() {
+        return ParticleEngine.TERRAIN_TEXTURE;
+    }
+
+    @Override
+    public void tick()
+    {
+        xo = x;
+        yo = y;
+        zo = z;
+
+        if (age++ >= lifetime)
+        {
+            remove();
+        }
+
+        if (age < lifetime / 4)
+        {
+            final float particleProgress = age / (lifetime / 4.0f);
+            size = maxSize * particleProgress;
+            gravity = 0.0f;
+        }
+        else
+        {
+            gravity = 0.5f;
+            yd -= 0.04D * gravity;
+            move(xd, yd, zd);
+            if (onGround)
+            {
+                xd *= 0.7D;
+                zd *= 0.7D;
+            }
+        }
+    }
+
+    @Override
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
+        if (this.tex == null) return;
+        float u0 = (float) this.tex.getSubIconU((uo / 4f));
+        float u2 = (float) this.tex.getSubIconU((uo / 4f) + 0.25f);
+        float v0 = (float) this.tex.getSubIconV((vo / 4f));
+        float v2 = (float) this.tex.getSubIconV((vo / 4f) + 0.25f);
+        float r = 0.1F * this.size;
+        float x = (float)(this.xo + (this.x - this.xo) * partialTick - xOff);
+        float y = (float)(this.yo + (this.y - this.yo) * partialTick - yOff);
+        float z = (float)(this.zo + (this.z - this.zo) * partialTick - zOff);
+        float br = 1.0f;
+        if (LightmapHelper.isLightmapEnabled()) {
+            t.setLightmapCoord(getLightmapCoord(partialTick));
+        } else {
+            br = getBrightness(partialTick);
+        }
+        t.setColorOpaque_F(this.rCol * br, this.gCol * br, this.bCol * br);
+        t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u2, v2);
+        t.addVertexWithUV(x - xa * r + xa2 * r, y + ya * r, z - za * r + za2 * r, u2, v0);
+        t.addVertexWithUV(x + xa * r + xa2 * r, y + ya * r, z + za * r + za2 * r, u0, v0);
+        t.addVertexWithUV(x + xa * r - xa2 * r, y - ya * r, z + za * r - za2 * r, u0, v2);
+    }
+
+    public FluidDripParticle setFullBright() {
+        fullBright = true;
+        return this;
+    }
+
+    @Override
+    public float getBrightness(float partialTick) {
+        if (fullBright) return 1f;
+        return super.getBrightness(partialTick);
+    }
+
+    @Override
+    public int getLightmapCoord(float partialTick) {
+        if (fullBright) {
+            int blockX = MathHelper.floor(x);
+            double d = (bb.maxY - bb.minY) * 0.66D;
+            int blockY = MathHelper.floor((y - (double) heightOffset) + d);
+            int blockZ = MathHelper.floor(z);
+            return LightmapHelper.getOverbrightLightmapCoord(world.getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ));
+        }
+        return super.getLightmapCoord(partialTick);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index 39dda81c3..4358d47a8 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -1,8 +1,11 @@
 package net.minecraft.client.entity.particle;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
@@ -66,5 +69,10 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda>
             }
             return null;
         });
+        addDispatch("dripWater", (world, x, y, z, motionX, motionY, motionZ, data) -> {
+            int color = BlockColorDispatcher.getInstance().getDispatch(Blocks.FLUID_WATER_STILL).getWorldColor(world, MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+            return new FluidDripParticle(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/water_flowing"));
+        });
+        addDispatch("dripLava", (world, x, y, z, motionX, motionY, motionZ, data) -> new FluidDripParticle(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/lava_flowing")).setFullBright());
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/MainMenuScreen.java b/src/main/java/net/minecraft/client/gui/MainMenuScreen.java
index 70e805cf0..54b361372 100644
--- a/src/main/java/net/minecraft/client/gui/MainMenuScreen.java
+++ b/src/main/java/net/minecraft/client/gui/MainMenuScreen.java
@@ -8,8 +8,6 @@ import java.io.InputStreamReader;
 import java.net.URI;
 import java.nio.charset.StandardCharsets;
 import java.util.ArrayList;
-import java.util.Calendar;
-import java.util.Date;
 import java.util.List;
 import java.util.Random;
 
@@ -44,7 +42,7 @@ public class MainMenuScreen extends Screen
 
     private static final Block[] BLOCKS_TO_DRAW = {
     		Blocks.STONE, Blocks.DIRT, Blocks.PLANKS_OAK, Blocks.COBBLE_STONE, Blocks.COBBLE_STONE_MOSSY, Blocks.BASALT, Blocks.LIMESTONE,
-    		Blocks.GRANITE, Blocks.BRICK_CLAY, Blocks.ICE, Blocks.WOOL, Blocks.BLOCK_SNOW, Blocks.OBSIDIAN, Blocks.NETHERRACK
+    		Blocks.GRANITE, Blocks.BRICK_CLAY, Blocks.ICE, Blocks.WOOL, Blocks.BLOCK_SNOW, Blocks.OBSIDIAN, Blocks.COBBLE_NETHERRACK
     };
     private static String[] logoBlockLayers = null;
     
diff --git a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
index 232b0d142..7a59d1248 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/data/AchievementPages.java
@@ -19,7 +19,7 @@ public class AchievementPages {
         if (hasInit) return;
         hasInit = true;
         overworldPage = register(new OverworldPage("gui.achievements.page.overworld", Blocks.GRASS.getDefaultStack()));
-        netherPage = register(new NetherPage("gui.achievements.page.nether", Blocks.NETHERRACK.getDefaultStack()));
+        netherPage = register(new NetherPage("gui.achievements.page.nether", Blocks.COBBLE_NETHERRACK.getDefaultStack()));
     }
     static {
         Achievements.init();
diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
index 33cfda288..5b007311f 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/NetherPage.java
@@ -50,7 +50,7 @@ public class NetherPage extends AchievementPage {
         final int offsetY = tileY + random.nextInt(3) - random.nextInt(3);
 
         int r = random.nextInt(50);
-        IconCoordinate texture = getTextureFromBlock(Blocks.NETHERRACK);
+        IconCoordinate texture = getTextureFromBlock(Blocks.COBBLE_NETHERRACK);
         if (offsetY >= bedrockLayer) {
             texture = getTextureFromBlock(Blocks.BEDROCK);
         } else if (r < 10) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 4cc8d5591..8eff72ef9 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -55,6 +55,7 @@ public class BlockModelDispatcher
         addDispatch(new StandardBlockModel<>(Blocks.BASALT_POLISHED).withTextures("minecraft:block/polished_basalt_top", "minecraft:block/polished_basalt_side"));
         addDispatch(new StandardBlockModel<>(Blocks.SLATE_POLISHED).withTextures("minecraft:block/polished_slate_top", "minecraft:block/polished_slate_side"));
         addDispatch(new StandardBlockModel<>(Blocks.PERMAFROST_POLISHED).withTextures("minecraft:block/polished_permafrost_top", "minecraft:block/polished_permafrost_side"));
+        addDispatch(new StandardBlockModel<>(Blocks.NETHERRACK_POLISHED).withTextures("minecraft:block/polished_netherrack_top", "minecraft:block/polished_netherrack_side"));
 
         addDispatch(new AxisAlignedBlockModel<>(Blocks.PILLAR_MARBLE).withTextures("minecraft:block/pillar_marble_top", "minecraft:block/pillar_marble_side"));
         addDispatch(new StandardBlockModel<>(Blocks.CAPSTONE_MARBLE).withTextures("minecraft:block/capstone_marble_top", "minecraft:block/capstone_marble_side"));
@@ -66,6 +67,7 @@ public class BlockModelDispatcher
         addDispatch(new StandardBlockModel<>(Blocks.LIMESTONE_CARVED).withTextures("minecraft:block/polished_limestone_top", "minecraft:block/carved_limestone"));
         addDispatch(new StandardBlockModel<>(Blocks.BASALT_CARVED).withTextures("minecraft:block/polished_basalt_top", "minecraft:block/carved_basalt"));
         addDispatch(new StandardBlockModel<>(Blocks.PERMAFROST_CARVED).withTextures("minecraft:block/polished_permafrost_top", "minecraft:block/carved_permafrost"));
+        addDispatch(new StandardBlockModel<>(Blocks.NETHERRACK_CARVED).withTextures("minecraft:block/polished_netherrack_top", "minecraft:block/carved_netherrack"));
 
         addDispatch(new StandardBlockModel<>(Blocks.PLANKS_OAK).withTextures("minecraft:block/planks_oak"));
         addDispatch(new PlanksPaintedBlockModel<>(Blocks.PLANKS_OAK_PAINTED));
@@ -166,6 +168,8 @@ public class BlockModelDispatcher
 
         addDispatch(new StandardBlockModel<>(Blocks.SPONGE_DRY).withTextures("minecraft:block/sponge"));
         addDispatch(new StandardBlockModel<>(Blocks.SPONGE_WET).withTextures("minecraft:block/sponge_wet"));
+        addDispatch(new PumiceBlockModel<>(Blocks.PUMICE_DRY).withTextures("minecraft:block/pumice"));
+        addDispatch(new PumiceBlockModel<>(Blocks.PUMICE_WET).withTextures("minecraft:block/pumice_overlay"));
 
         addDispatch(new MossyStoneBlockModel<>(Blocks.MOSS_STONE).withTextures("minecraft:block/stone"));
         addDispatch(new MossyStoneBlockModel<>(Blocks.MOSS_BASALT).withTextures("minecraft:block/basalt"));
@@ -409,8 +413,16 @@ public class BlockModelDispatcher
         addDispatch(new RedstonePumpkinBlockModel(Blocks.PUMPKIN_REDSTONE).withTextures("minecraft:block/pumpkin_top", "minecraft:block/pumpkin_bottom", "minecraft:block/pumpkin_redstone", "minecraft:block/pumpkin_side", "minecraft:block/pumpkin_side", "minecraft:block/pumpkin_side"));
 
 
+        addDispatch(new StandardBlockModel<>(Blocks.COBBLE_NETHERRACK).withTextures("minecraft:block/cobbled_netherrack"));
+        addDispatch(new StandardBlockModel<>(Blocks.COBBLE_NETHERRACK_IGNEOUS).withTextures("minecraft:block/cobbled_netherrack_igneous").withOverbrightTexture("minecraft:block/cobbled_netherrack_igneous_overlay"));
+        addDispatch(new StandardBlockModel<>(Blocks.COBBLE_NETHERRACK_MOSSY).withTextures("minecraft:block/cobbled_netherrack_mossy"));
         addDispatch(new StandardBlockModel<>(Blocks.NETHERRACK).withTextures("minecraft:block/netherrack"));
-        addDispatch(new StandardBlockModel<>(Blocks.NETHERRACK_IGNEOUS).withTextures("minecraft:block/netherrack_igneous").withOverbrightTexture("minecraft:block/netherrack_igneous_overlay"));
+        addDispatch(new StandardBlockModel<>(Blocks.BRICK_NETHERRACK).withTextures("minecraft:block/brick_netherrack"));
+        addDispatch(new SlabBlockModel<>(Blocks.SLAB_NETHERRACK_POLISHED));
+        addDispatch(new SlabBlockModel<>(Blocks.SLAB_COBBLE_NETHERRACK));
+        addDispatch(new SlabBlockModel<>(Blocks.SLAB_BRICK_NETHERRACK));
+        addDispatch(new StairsBlockModel<>(Blocks.STAIRS_COBBLE_NETHERRACK));
+        addDispatch(new StairsBlockModel<>(Blocks.STAIRS_BRICK_NETHERRACK));
 
         addDispatch(new StandardBlockModel<>(Blocks.SOULSAND).withTextures("minecraft:block/soulsand"));
         addDispatch(new StandardBlockModel<>(Blocks.GLOWSTONE).withTextures("minecraft:block/glowstone"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/PumiceBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PumiceBlockModel.java
new file mode 100644
index 000000000..90f16ade1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/PumiceBlockModel.java
@@ -0,0 +1,62 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.Nullable;
+
+public class PumiceBlockModel<T extends Block> extends StandardBlockModel<T>{
+    private boolean lavaFlag = false;
+    public PumiceBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        lavaFlag = true;
+        boolean ob = renderBlocks.overbright;
+        renderBlocks.overbright = true;
+//        block.setBlockBounds(0.005, 0.005, 0.005, 0.995, 0.995, 0.995);
+        boolean rendered = super.render(tessellator, x, y, z);
+
+        renderBlocks.overbright = ob;
+        lavaFlag = false;
+//        block.setBlockBounds(0, 0, 0, 1, 1, 1);
+        rendered |= super.render(tessellator, x, y, z);
+        return rendered;
+    }
+
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        lavaFlag = true;
+        boolean ob = renderBlocks.overbright;
+        renderBlocks.overbright = true;
+        block.setBlockBounds(0.005, 0.005, 0.005, 0.995, 0.995, 0.995);
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, LightmapHelper.getLightmapCoord(15, 15));
+
+        renderBlocks.overbright = ob;
+        lavaFlag = false;
+        if (LightmapHelper.isLightmapEnabled()) {
+            lightmapCoordinate = Minecraft.getMinecraft(this).thePlayer.getLightmapCoord(1f);
+        }
+        block.setBlockBounds(0, 0, 0, 1, 1, 1);
+        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+        if (lavaFlag) return TextureRegistry.getTexture("minecraft:block/lava_still");
+        return super.getBlockTextureFromSideAndMetadata(side, data);
+    }
+
+    @Override
+    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+        if (lavaFlag) return TextureRegistry.getTexture("minecraft:block/lava_still");
+        return super.getBlockOverbrightTextureFromSideAndMeta(side, data);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/StandardBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/StandardBlockModel.java
index 4ce568b70..0925fa221 100644
--- a/src/main/java/net/minecraft/client/render/block/model/StandardBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/StandardBlockModel.java
@@ -113,7 +113,7 @@ public class StandardBlockModel<T extends Block> extends BlockModel<T>{
 //			GL11.glEnable(GL11.GL_LIGHTING);
 		}
 
-		GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+		GL11.glTranslatef(0.5F, yOffset, 0.5F);
 	}
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 6cc41a2fc..64dfe09cc 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -207,6 +207,7 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
 
         addDispatch(new StandardItemModel(Items.WAND_MONSTER_SPAWNER, "minecraft").setFull3D());
         addDispatch(new StandardItemModel(Items.DOOR_STEEL, "minecraft"));
+        addDispatch(new PaintbrushItemModel(Items.PAINTBRUSH, "minecraft").setFull3D());
 
         addDispatch(new StandardItemModel(Items.RECORD_13, "minecraft"));
         addDispatch(new StandardItemModel(Items.RECORD_CAT, "minecraft"));
diff --git a/src/main/java/net/minecraft/client/render/item/model/PaintbrushItemModel.java b/src/main/java/net/minecraft/client/render/item/model/PaintbrushItemModel.java
new file mode 100644
index 000000000..e0b5cb18e
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/item/model/PaintbrushItemModel.java
@@ -0,0 +1,34 @@
+package net.minecraft.client.render.item.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.PaintBrushItem;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class PaintbrushItemModel extends StandardItemModel {
+    public static IconCoordinate emptyIcon = TextureRegistry.getTexture("minecraft:item/paintbrush");
+    public static IconCoordinate[] paintbrushIcons = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    static {
+        for (DyeColor c : DyeColor.itemOrderedColors()){
+            paintbrushIcons[c.itemMeta] = TextureRegistry.getTexture("minecraft:item/paintbrush_" + c.colorID);
+        }
+    }
+
+    public PaintbrushItemModel(Item item, String namespace) {
+        super(item, namespace);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
+        final DyeColor color = ((PaintBrushItem) itemStack.getItem()).getColor(itemStack);
+        if (color == null) {
+            return emptyIcon;
+        }
+        return paintbrushIcons[color.itemMeta];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/sound/SoundRepository.java b/src/main/java/net/minecraft/client/sound/SoundRepository.java
index f0da324ee..31061d450 100644
--- a/src/main/java/net/minecraft/client/sound/SoundRepository.java
+++ b/src/main/java/net/minecraft/client/sound/SoundRepository.java
@@ -6,13 +6,13 @@ import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.ArrayList;
-import java.util.List;
-import java.util.Random;
+import java.util.*;
 
 public class SoundRepository extends Registry<NamedSoundRepository> {
     protected static Minecraft mc = null;
     public static SoundRepository SOUNDS = null;
+    public Set<String> cachedRepositoryErrors = new HashSet<>();
+    public Set<NamespaceID> cachedEntryErrors = new HashSet<>();
     public SoundRepository() {
         registerNamespace("minecraft");
     }
@@ -30,7 +30,10 @@ public class SoundRepository extends Registry<NamedSoundRepository> {
         if (namespaceID == null) return null;
         NamedSoundRepository soundRepository = getItem(namespaceID.namespace);
         if (soundRepository == null) {
-            System.err.println("Could not find sound repository under namespace '" + namespaceID.namespace + "'!");
+            if (!cachedRepositoryErrors.contains(namespaceID.namespace)) {
+                System.err.println("Could not find sound repository under namespace '" + namespaceID.namespace + "'!");
+                cachedRepositoryErrors.add(namespaceID.namespace);
+            }
             return null;
         }
         return soundRepository.getItem(namespaceID.value);
@@ -45,7 +48,10 @@ public class SoundRepository extends Registry<NamedSoundRepository> {
         if (namespaceID == null) return null;
         SoundEvent event = getSoundEvent(namespaceID);
         if (event == null) {
-            System.err.println("Count not find sound event in namespace '" + namespaceID.namespace + "' matching key '" + namespaceID.value + "'!");
+            if (!cachedEntryErrors.contains(namespaceID)) {
+                System.err.println("Could not find sound event in namespace '" + namespaceID.namespace + "' matching key '" + namespaceID.value + "'!");
+                cachedEntryErrors.add(namespaceID);
+            }
             return null;
         }
         return event.getRandomEntry();
